require_relative 'player'
require_relative 'die'
require_relative 'game_turn'

module StudioGame
class Game
attr_reader :title

  def initialize(title)
    @title = title
    @players = []
  end

  def load_players(from_file)
  File.readlines(from_file).each do |line|
    name, health = line.split(',')
    player = Player.new(name, Integer(health))
    add_player(player)
  end
end

  def add_player(a_player)
    @players.push(a_player)
  end

  def play(rounds)
  puts "There are #{@players.size} players in #{@title}: "
  @players.each do |player|
    puts player
  end

  treasures = TreasureTrove::TREASURES
  puts "\nThere are #{treasures.size} treasures to be found:"
  treasures.each do |treasures|
    puts "A #{treasures.name} is worth #{treasures.points} points."
end

  1.upto(rounds) do |round|
    puts "\nRound #{round}:"
    @players.each do |player|
      GameTurn.take_turn(player)
      puts player
    end
  def print_stats
  strong_players = @players.select { |player| player.strong? }
  wimpy_players = @players.reject { |player| player.strong? }
  sorted_players = @players.sort { |a, b| b.score <=> a.score }
  puts "\n#{@title} Statistics:"
  puts "\n#{strong_players.size} strong players:"
    strong_players.each do |player|
  puts "#{player.name} (#{player.health})"
    end
  puts "\n#{wimpy_players.size} wimpy players:"
    wimpy_players.each do |player|
  puts "#{player.name} (#{player.health})"
    end
  puts "\n#{@title} High Scores:"
@players.sort.each do |player|
  formatted_name = player.name.ljust(20, '.')
  puts "#{formatted_name} #{player.score}"
end
@players.each do |player|
  puts "\n#{player.name}'s point totals:"
  puts "#{player.points} grand total points"
end
@players.sort.each do |player|
  puts "\n#{player.name}'s point totals:"
  player.each_found_treasure do |treasure|
    puts "#{treasure.points} total #{treasure.name} points"
  end
  puts "#{player.points} grand total points"
end
def save_high_scores(to_file="high_scores.txt")
  File.open(to_file, "w") do |file|
    file.puts "#{@title} High Scores:"
    @players.sort.each do |player|
      formatted_name = player.name.ljust(20, '.')
      file.puts "#{formatted_name} #{player.score}"
    end
  end
end
  end
  end
end
end
end
